﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Web.Optimization;
using BundleTransformer.Core.Orderers;
using System.Xml.Linq;
using System.Xml;

namespace WebApplication1
{
    public class Global : System.Web.HttpApplication
    {

        void Application_Start(object sender, EventArgs e)
        {
            // 在应用程序启动时运行的代码
            BundleTable.EnableOptimizations = true;
            //ScriptBundle baseScriptBundle = new ScriptBundle("~/js/basev1");
            //baseScriptBundle.Include("~/Scripts/jquery-1.8.2.min.js");
            //ScriptBundle scriptBundle = new ScriptBundle("~/js/plusv1");
            //scriptBundle.Include("~/Scripts/jquery.cookies.2.2.0.min.js",
            //    "~/Scripts/jquery.easyui.min.js",
            //    "~/Scripts/jquery.form-2.4.3.js",
            //    "~/Scripts/jquery.jPrintArea.js",
            //    "~/Scripts/jquery.jtimepicker.js",
            //    "~/Scripts/json2.js"
            //    );

            //scriptBundle.Orderer = new NullOrderer();

            //StyleBundle cssBundle = new StyleBundle("~/style/allv1");
            //cssBundle.Include("~/styles/Site.css");
            //BundleTable.Bundles.Add(cssBundle);
            //BundleTable.Bundles.Add(baseScriptBundle);
            //BundleTable.Bundles.Add(scriptBundle);

            XmlDocument doc = new XmlDocument();
            doc.Load(HttpContext.Current.Server.MapPath("~/BundleConfig.xml"));

            XmlNodeList scriptList = doc.DocumentElement.SelectNodes("scripts/script");
            if (scriptList!=null&&scriptList.Count>0)
            {
                foreach (XmlNode node in scriptList)
                {
                   string virtualPath  =node.Attributes["path"].Value.Trim();
                   if (!string.IsNullOrEmpty(virtualPath))
                   {
                       var scriptBundle = new ScriptBundle(virtualPath);
                       foreach (XmlNode fileNode in node.ChildNodes)
                       {
                           scriptBundle.Include(fileNode.InnerText.Trim());
                       }
                       BundleTable.Bundles.Add(scriptBundle);
                   }
                }
            }
            XmlNodeList cssList = doc.DocumentElement.SelectNodes("styles/style");
            if (cssList != null && cssList.Count > 0)
            {
                foreach (XmlNode node in cssList)
                {
                    string virtualPath = node.Attributes["path"].Value.Trim();
                    if (!string.IsNullOrEmpty(virtualPath))
                    {
                        var cssBundle = new StyleBundle(virtualPath);
                        foreach (XmlNode fileNode in node.ChildNodes)
                        {
                            cssBundle.Include(fileNode.InnerText.Trim());
                        }
                        BundleTable.Bundles.Add(cssBundle);
                    }

                }
            }
            
        }

        void Application_End(object sender, EventArgs e)
        {
            //  在应用程序关闭时运行的代码

        }

        void Application_Error(object sender, EventArgs e)
        {
            // 在出现未处理的错误时运行的代码

        }

        void Session_Start(object sender, EventArgs e)
        {
            // 在新会话启动时运行的代码

        }

        void Session_End(object sender, EventArgs e)
        {
            // 在会话结束时运行的代码。 
            // 注意: 只有在 Web.config 文件中的 sessionstate 模式设置为
            // InProc 时，才会引发 Session_End 事件。如果会话模式设置为 StateServer 
            // 或 SQLServer，则不会引发该事件。

        }

    }
}
